#include <stdio.h>
#include <stdlib.h>
#include<time.h>


void deftabl(int *L, int *C)/*definit la taille du tableau qui va contenir les cellules*/
{
 printf("Combien de lignes votre tableau thorique possede-t-il? : ");
 scanf("%d",&(*L));
 *L=*L+2;
 printf("\nCombien de colonnes possede votre tableau thorique? : ");
 scanf("%d",&(*C));
 *C=*C+2;
}




void remplir(int L,int C,int T[L][C])/*remplit le tableau par des cellules mortes ou vivantes*/
{
 int x,i,j,y;
 do
 {
     printf("\nVoulez-vous entrez des valeurs manuellement (taper 1) ou bien travailler avec \ndes cases aleatoires (taper 2)?\n");
     scanf("%d",&x);
 }
 while((x!=1) && (x!=2));
 for(i=1;i<=(L-2);i=i+1)
 {
     for(j=1;j<=(C-2);j=j+1)
     {
         if(x==2)
         {
             T[i][j]=rand()%2;
         }
         else
         {
             do
             {
                     printf("\nLa case de la %d eme ligne et %d eme colonne est une case morte (taper 0)\nou une case vivante(taper 1)? :",i,j);
                     scanf("%d",&y);
             }
             while((y!=0) && (y!=1));
             T[i][j]=y;
         }
     }
 }
}




void thor (int L,int C,int T[L][C])/*remplit les bords thoriques de notre tableau*/
{
 int i;
 for(i=1;i<=(C-2);i=i+1)
 {
     T[0][i]=T[L-2][i];
     T[L-1][i]=T[1][i];
 }
 for(i=0;i<=(L-1);i=i+1)
 {
     T[i][0]=T[i][C-2];
     T[i][C-1]=T[i][1];
 }
}



void affichage (int L,int C,int T[L][C])/*affiche le tableau*/
{
 int i,j,x;
 
 for(i=1;i<=(L-2);i=i+1)
 {
     for(j=1;j<=(C-2);j=j+1)
     {
         if(T[i][j]==0)
         {
             printf(" ");
         }
         else
         {
             if(T[i][j]==1)
             {
                 x=178;
                 printf("%c",x);
             }
             else
             {
                 x=177;
                 printf("%c",x);
             }
         }
     }
     printf("\n");
 }
}

int calcul(int L,int C,int T[L][C],int i,int j)/*calcul le nombre de case vivantes dans les 9 cases composes par les cases entourant celle o nous sommes arrets plus celle-ci*/
{
 int a,b,x=0;
 for(a=(i-1);a<=(i+1);a++)
 {
      for(b=(j-1);b<=(j+1);b++)
      {
           if((T[a][b]==1)||(T[a][b]==2))
           {
                x=x+1;
           }
      }
 }
 return x;
}


void changement(int L,int C,int T[L][C],int x,int i,int j)/*transforme la case cible selon les rgles du Jeu de la Vie*/
{
 if((T[i][j]==1)||(T[i][j]==2))
 {
     x=x-1;
     if((x==2)||(x==3))
     {
         T[i][j]=1;/*case devient vivante*/
     }
     else
     {
         T[i][j]=0;/*case devient morte*/
     }
 }
 else
 {
     if(x==3)
     {
      T[i][j]=2;/*case devient naissante*/
     }
 }
}     

void copie(int L,int C, int P[L][C], int T[L][C])
{
 int i,j;
 for(i=0;i<L;i++)
 {
     for(j=0;j<C;j++)
     {
         P[i][j]=T[i][j];
     }
 }
}


void generation(int L,int C,int T[L][C])/*effectue le passage d'une gnration  une autre*/
{
 int i,j,P[L][C],nbvivantes;
 copie(L,C,P,T);
 for(i=1;i<=(L-2);i=i+1)
 {
     for(j=1;j<=(C-2);j=j+1)
     {
          nbvivantes=calcul(L,C,P,i,j);
          changement(L,C,T,nbvivantes,i,j);
     }
 }
 system("CLS");
 affichage(L,C,T);
}

int main(int argc, char *argv[])/*programme principal*/
{
 int L,C,N,i;
 srand(time(0));
 printf("                          Bienvenue dans ce programme.\n\nVous allez etre invite a jouer au jeu de la vie. Amusez-vous bien.\n\n"); 
 deftabl(&L,&C);
 int T[L][C];
 remplir(L,C,T);
 printf("\nCombien de generations voulez-vous executer? : ");
 scanf("%d",&N);
 system("CLS");
 affichage(L,C,T);
 for(i=1;i<=N;i=i+1)
 {
     system("PAUSE");
     thor(L,C,T);
     generation(L,C,T);
 }
  system("PAUSE");	
  return 0;
}
