#include <stdio.h>
#include <stdlib.h>
#include<time.h>


void defvariables(int *L, int *C,int *N, float *temps,int *i)/*definit les variables de notre programme*/
{
 float x;
 do
 {
     printf("\nEntrez la hauteur de votre espace thorique\nVeuillez taper un nombre entier positif : ");
     scanf("%f",&x);
     *L=x;
 }
 while((*L<1)||(*L!=x));
 *L=*L+2;
 do
 {
     printf("\nEntrez la largeur de votre espace thorique?\nVeuillez taper un nombre entier positif : ");
     scanf("%f",&x);
     *C=x;
 }
 while((*C<1)||(*C!=x));
 *C=*C+2;
 printf("\nCombien de generations voulez-vous executer? : ");
 do
 {
     printf("\nVeuillez taper un nombre entier positif :");
     scanf("%f",&x);
     *N=x;
 }
 while((*N<1)||(*N!=x));
 do
 {
     printf("\nVoulez-vous utiliser :\n-le mode pas a pas (tapez 1) \n-le mode automatique (tapez 2)\n");
     scanf("%d",&(*i));
 }
 while(((*i)!=1)&&((*i)!=2));
 if((*i)==2)
 {
     printf("\nCombien de temps voulez vous que dure une generation en millisecondes? :");
     scanf("%f",&(*temps));
     while(temps<0)
     {
         printf("Le temps est toujours exprime par une valeur positive!\nVeuillez taper un nombre positif qui determinera la duree de la pause entre \nchaque generation en millisecondes :");
         scanf("%f",&(*temps));
     }
 }
}




void remplir(int L,int C,int T[L][C])/*remplit le tableau par des cellules mortes ou vivantes*/
{
 int x,i,j,y;
 float a;
 char rep;
 do
 {
     printf("\nVoulez-vous\n-entrez des valeurs manuellement (taper 1)\n-travailler avec des cases aleatoires (taper 2)\n");
     scanf("%d",&x);
 }
 while((x!=1) && (x!=2));
  if(x==2)
  {
      for(i=1;i<=(L-2);i=i+1)
      {
          for(j=1;j<=(C-2);j=j+1)
          {
        
              T[i][j]=rand()%2;
          }
      }
  }
  else
  {
      
      for(i=1;i<=(L-2);i=i+1)
      {
          for(j=1;j<=(C-2);j=j+1)
          {
        
              T[i][j]=0;
          }
      }
      do
      {
          do
          {
              printf("\nSur quelle ligne voulez-vous ajouter une case vivante ? :");
              scanf("%f",&a);
              i=a;
          }
          while(((i<1)||(i>(L-2)))||(i!=a));
          do
          {
              printf("\nSur quelle colonne voulez-vous ajouter votre case ? :");
              scanf("%f",&a);
              j=a;
          }
          while(((j<1)||(j>(C-2)))||(j!=a));  
          T[i][j]=1;
          do
          {
              printf("\nVoulez-vous entrer une autre case vivante? (O/N) :");
              scanf("%c",&rep);
          }
          while((rep!='O')&&(rep!='N'));
      }
      while(rep=='O');
 }
}




void thor (int L,int C,int T[L][C])/*remplit les bords thoriques de notre tableau*/
{
 int i;
 for(i=1;i<=(C-2);i=i+1)
 {
     T[0][i]=T[L-2][i];
     T[L-1][i]=T[1][i];
 }
 for(i=0;i<=(L-1);i=i+1)
 {
     T[i][0]=T[i][C-2];
     T[i][C-1]=T[i][1];
 }
}



void affichage (int L,int C,int T[L][C])/*affiche le tableau*/
{
 int i,j,x;
 
 for(i=1;i<=(L-2);i=i+1)
 {
     for(j=1;j<=(C-2);j=j+1)
     {
         if(T[i][j]==0)
         {
             printf(" ");
         }
         else
         {
             if(T[i][j]==1)
             {
                 x=178;/*case blanche = case vivante*/
                 printf("%c",x);
             }
             else
             {
                 x=177;/*case grise = case naissante*/
                 printf("%c",x);
             }
         }
     }
     printf("\n");
 }
}

int calcul(int L,int C,int T[L][C],int i,int j)/*calcul le nombre de case vivantes dans les 9 cases composes par les cases entourant celle o nous sommes arrets plus celle-ci*/
{
 int a,b,x=0;
 for(a=(i-1);a<=(i+1);a++)
 {
      for(b=(j-1);b<=(j+1);b++)
      {
           if((T[a][b]==1)||(T[a][b]==2))
           {
                x=x+1;
           }
      }
 }
 return x;
}


void changement(int L,int C,int T[L][C],int x,int i,int j)/*transforme la case cible selon les rgles du Jeu de la Vie*/
{
 if((T[i][j]==1)||(T[i][j]==2))
 {
     x=x-1;
     if((x==2)||(x==3))
     {
         T[i][j]=1;/*case devient vivante*/
     }
     else
     {
         T[i][j]=0;/*case devient morte*/
     }
 }
 else
 {
     if(x==3)
     {
      T[i][j]=2;/*case devient naissante*/
     }
 }
}     

void copie(int L,int C, int P[L][C], int T[L][C])/*copie le tableau T dans le tableau P*/
{
 int i,j;
 for(i=0;i<L;i++)
 {
     for(j=0;j<C;j++)
     {
         P[i][j]=T[i][j];
     }
 }
}


void generation(int L,int C,int T[L][C])/*effectue le passage d'une gnration  une autre*/
{
 int i,j,P[L][C],nbvivantes;
 copie(L,C,P,T);
 for(i=1;i<=(L-2);i=i+1)
 {
     for(j=1;j<=(C-2);j=j+1)
     {
          nbvivantes=calcul(L,C,P,i,j);
          changement(L,C,T,nbvivantes,i,j);
     }
 }
 system("CLS");
 affichage(L,C,T);
}

int main(int argc, char *argv[])/*programme principal*/
{
 int L,C,N,i,x;
 float temps;
 char rep;
 srand(time(0));
 printf("Automate cellulaire\n\n"); 
 do
 {
     defvariables(&L,&C,&N,&temps,&x);
     int T[L][C];
     remplir(L,C,T);
     system("CLS");
     affichage(L,C,T);
     for(i=1;i<=N;i=i+1)
     {
         if(x==2)
         {
             sleep((int)temps);
         }
         else
         {
             getch();
         }
         thor(L,C,T);
         generation(L,C,T);
     }
     do
     {
         printf("\nVoulez-vous faire une autre simulation? (O/N) :");
         scanf("%c",&rep);
         system("CLS");
     }
     while((rep!='O')&&(rep!='N'));
 }
 while(rep=='O');
 system("PAUSE");	
 return 0;
}
